<?php
/*======================================================================*\
|| #################################################################### ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2013 Fillip Hannisdal AKA Revan/NeoRevan/Belazor 	  # ||
|| # All Rights Reserved. 											  # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # ---------------------------------------------------------------- # ||
|| # You are not allowed to use this on your server unless the files  # ||
|| # you downloaded were done so with permission.					  # ||
|| # ---------------------------------------------------------------- # ||
|| #################################################################### ||
\*======================================================================*/

// ####################### SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// #################### DEFINE IMPORTANT CONSTANTS #######################
define('THIS_SCRIPT', 'vbsecurity');
define('IN_VBSECURITY', true);

if (isset($_REQUEST['do']) AND $_REQUEST['do'] == 'ajax')
{
	define('CSRF_PROTECTION', true);
	define('LOCATION_BYPASS', 1);
	define('NOPMPOPUP', 1);
	define('VB_ENTRY', 'ajax.php');
	define('SESSION_BYPASS', true);
	define('VB_ENTRY_TIME', microtime(true));
}

// ################### PRE-CACHE TEMPLATES AND DATA ######################
// get special phrase groups
$phrasegroups = array('dbtech_vbsecurity', 'user', 'album');

// get templates used by all actions
$globaltemplates = array(
	'dbtech_vbsecurity',
);

// pre-cache templates used by specific actions
$actiontemplates = array(
	'main' => array(
		'dbtech_vbsecurity_main',
	),
);

// get special data templates from the datastore
require('./dbtech/vbsecurity/includes/specialtemplates.php');
$specialtemplates = $extracache;

// ############################### default do value ######################
if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = $_GET['do'] = 'main';
}

// ######################### REQUIRE BACK-END ############################
require_once('./global.php');

if (!class_exists('vB_Template'))
{
	// Ensure we have this
	require_once(DIR . '/dbtech/vbsecurity/includes/class_template.php');
}

if (!class_exists('VBSECURITY'))
{
	eval(standard_error($vbphrase['dbtech_vbsecurity_deactivated']));
}


// ########################################################################
// ######################### START MAIN SCRIPT ############################
// ########################################################################

if (!empty($_POST['do']))
{
	// $_POST requests take priority
	$action = $_POST['do'];
}
else if (!empty($_GET['do']))
{
	// We had a GET request instead
	$action = $_GET['do'];
}
else
{
	// No request
	$action = 'main';
}

// Strip non-valid characters
$action = preg_replace('/[^\w-]/i', '', $action);

if (!$vbulletin->options['dbtech_vbsecurity_active'])
{
	// Sb is shut off
	eval(standard_error($vbulletin->options['dbtech_vbsecurity_closedreason']));
}

if (VBSECURITY::$permissions['isbanned'])
{
	// Can't view Activity
	print_no_permission();
}

// begin navbits
$navbits = array('vbsecurity.php' . $vbulletin->session->vars['sessionurl_q'] => $vbphrase['dbtech_vbsecurity_vbsecurity']);

// Core page template
$page_template = 'dbtech_vbsecurity';

if (!file_exists(DIR . '/dbtech/vbsecurity/actions/' . $action . '.php'))
{
	if (!file_exists(DIR . '/dbtech/vbsecurity_pro/actions/' . $action . '.php'))
	{
		// Throw error from invalid action
		eval(standard_error(fetch_error('dbtech_vbsecurity_error_x', $vbphrase['dbtech_vbsecurity_invalid_action'])));
	}
	else
	{
		// Include the selected file
		include_once(DIR . '/dbtech/vbsecurity_pro/actions/' . $action . '.php');	
	}
}
else
{
	// Include the selected file
	include_once(DIR . '/dbtech/vbsecurity/actions/' . $action . '.php');	
}

if (intval($vbulletin->versionnumber) == 3)
{
	// Create navbits
	$navbits = construct_navbits($navbits);	
	eval('$navbar = "' . fetch_template('navbar') . '";');
}
else
{
	$navbar = render_navbar_template(construct_navbits($navbits));	
}

if (intval($vbulletin->versionnumber) == 3)
{
	// Begin the monster template
	$headinclude .= vB_Template::create('dbtech_vbsecurity.css')->render();
}

// Show branding or not
$show['dbtech_vbsecurity_producttype'] = (VBSECURITY::$isPro ? ' (Pro)' : ' (Lite)');

// Finish the main template
$templater = vB_Template::create($page_template);
	$templater->register_page_templates();
	$templater->register('navclass', 		$navclass);
	$templater->register('HTML', 			$HTML);
	$templater->register('navbar', 			$navbar);
	$templater->register('pagetitle', 		$pagetitle);
	$templater->register('pagedescription', $pagedescription);
	$templater->register('template_hook', 	$template_hook);
	$templater->register('includecss', 		$includecss);
	$templater->register('year',			date('Y'));
	$templater->register('jQueryVersion',	VBSECURITY::$jQueryVersion);
	$templater->register('jQueryPath',		VBSECURITY::jQueryPath());
	$templater->register('version',			'1.1.4 Patch Level 3');
	$templater->register('versionnumber', 	'114pl3');
	$templater->register('headinclude', 	$headinclude);
print_output($templater->render());